#!/usr/bin/env python
# -*- coding:UTF-8 -*-

###this script is translate from ubuntu-cn forum's eexpress's perl script
###just function realize but apprearence not so look like it's perl script
###and so...any advice please mailto: leeaman@163.com,thx(^*_*^)

import string,re,cairo,datetime,urllib,os

##########draw rounded rectangles##########################################
def draw_round_rectangles(context,x,y,w,h,r):
	context.move_to(x+r,y)
	context.line_to(x+w-r,y)
	context.curve_to(x+w,y,x+w,y,x+w,y+r)
	context.line_to(x+w,y+h-r)
	context.curve_to(x+w,y+h,x+w,y+h,x+w-r,y+h)
	context.line_to(x+r,y+h)
	context.curve_to(x,y+h,x,y+h,x,y+h-r)
	context.line_to(x,y+r)
	context.curve_to(x,y,x,y,x+r,y)
	context.fill()
	return
###########################################################################

############draw weather date week weather meaage etc.#####################
def draw_weather_message(context,n,m,bool_text):
	context.set_font_size(15)
	context.move_to(n*128+10,30)
	week_day=list_message[m*7+1].split(' ')
	context.text_path(week_day[0])
	context.move_to(n*128+20,60)
	context.text_path(week_day[1])
	context.move_to(n*128+10,180)
	context.text_path(list_message[m*7+3])
	context.move_to(n*128+10,200)
	context.text_path(list_message[m*7+4])
	bool_match=re.search('/',list_message[m*7+5])
	if bool_match:
		message_split=list_message[m*7+5].split('/')
		context.move_to(n*128+10,220)
		context.text_path(message_split[0])
		context.move_to(n*128+10,240)
		context.text_path(message_split[1])
	else:
		context.move_to(n*128+10,230)
		context.text_path(list_message[m*7+5])
	if bool_text:
		context.stroke()
	else:
		context.fill()
	return
###########################################################################

##########draw weather png icon############################################
def draw_weather_png(context,m):
	context.set_operator(cairo.OPERATOR_DEST_OVER)
	str_message=re.sub("大到|中到|小到","",list_message[m*7+3])
	bool_match=re.search('转',str_message)
	if bool_match:
		file_name_list=str_message.split('转')
		if os.path.exists(png_dir+file_name_list[0]+'.png') and os.path.exists(png_dir+file_name_list[1]+'.png'):
			img1=cairo.ImageSurface.create_from_png(png_dir+file_name_list[0]+'.png')
			img2=cairo.ImageSurface.create_from_png(png_dir+file_name_list[1]+'.png')
			context.set_source_surface(img1,5+128*m,75)
			context.paint()
			context.set_source_surface(img2,50+128*m,85)
			context.paint()
	else:
		if os.path.isfile(png_dir+str_message+'.png'):
			img=cairo.ImageSurface.create_from_png(png_dir+str_message+'.png')
			context.set_source_surface(img,20+128*m,80)
			context.paint()
	return
###########################################################################

#################main program #############################################

################get weather message,week numeber,and format message########
url_address=urllib.urlopen("http://qq.ip138.com/weather/guangdong/deqing.wml")
#url_address=urllib.urlopen("http://qq.ip138.com/weather/neimenggu/DaErHanMaoMingAn.wml")
wml_weather=url_address.read()
url_address.close()
sTemp=wml_weather.split('\n')
sTitle=re.sub('<card title="|">',"",sTemp[6])
str_message=re.sub('<b>|</b>|<br/>',"\n",sTemp[9])
list_message=str_message.split('\n')
s1=list_message[1].split(' ')
s2=s1[0].split('-')
s_year,s_mon,s_day=int(s2[0]),int(s2[1]),int(s2[2])
today=datetime.datetime(s_year,s_mon,s_day)
num_week_today=today.weekday()
###the weather png icon directory,change to yourself's directory###########
png_dir='/home/missing/cairo-weather/'
###########################################################################

##################initial surface##########################################
WIDTH,HEIGHT=896,256
surface = cairo.ImageSurface (cairo.FORMAT_ARGB32, WIDTH, HEIGHT)
ctx = cairo.Context (surface)
###########################################################################

##################drawing address message##################################
ctx.set_source_rgba(0,0.75,0.4,0.6)
ctx.select_font_face("Sans",cairo.FONT_SLANT_NORMAL,cairo.FONT_WEIGHT_BOLD)
ctx.set_font_size(100*26/len(sTitle))
x_bearing, y_bearing, width, height = ctx.text_extents(sTitle)[:4]
ctx.move_to(448 - width / 2 - x_bearing, 90 - height / 2 - y_bearing)
ctx.text_path(sTitle)
ctx.set_line_width(1)
ctx.stroke()
###########################################################################

###################draw weather message####################################
ctx.set_source_rgba(0,0,0,0.8)
ctx.set_line_width(1)
for i in range(7):
	draw_weather_message(ctx,i,i,1)
ctx.set_source_rgba(0.855,0.255,0,1)
for i in range(7):
	draw_weather_message(ctx,i,i,0)
###########################################################################

##################draw round rectangles####################################
ctx.set_source_rgba(0,0,0,0.6)
for n in range(7):
	draw_round_rectangles(ctx,128*n,0,128,256,20)
ctx.set_source_rgba(0.5,0,0,0.2)
draw_round_rectangles(ctx,0,0,128,256,20)
ctx.set_source_rgba(0,0,0.5,0.2)
posX=(6-num_week_today)*128
if posX==128:
	draw_round_rectangles(ctx,128,0,128,256,20)
elif posX==0:
	draw_round_rectangles(ctx,768,0,128,256,20)
else:
	draw_round_rectangles(ctx,posX,0,128,256,20)
	draw_round_rectangles(ctx,posX-128,0,128,256,20)
###########################################################################

##################draw weather icon########################################
for m in range(7):
	draw_weather_png(ctx,m)
###########################################################################
del ctx
surface.write_to_png ("/tmp/weather.png") # Output to PNG
####background's path,change to the path as your wish######################
os.system('habak -ms "/home/missing/.calendar/cc.jpg" -mp -75,420 -hi /tmp/weather.png')
#########the end of main program###########################################
